﻿@using Business.Repository.IRepository
@using Models.MatchData

@inject IModalDialogService ModalDialog
@inject IJSRuntime JsRuntime
@inject IMatchCommentaryRepository MatchCommentaryRepository
@inject NavigationManager NavigationManager

<div class="row mt-2 mb-5">
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <EditForm Model="@MatchCommentaryModel" OnValidSubmit="HandleCreateUpdate">
                    <DataAnnotationsValidator />
                    @*<ValidationSummary />*@

                    <div class="form-group">
                        <label>Minute</label>
                        <input type="number" class="form-control" @bind="MatchCommentaryModel.Minute" />
                        <ValidationMessage For="() => MatchCommentaryModel.Minute" />
                    </div>

                    <div class="form-group">
                        <label>Comment</label>
                        <textarea class="form-control" rows="3" @bind="MatchCommentaryModel.Comment"></textarea>
                        <ValidationMessage For="() => MatchCommentaryModel.Comment" />
                    </div>
                    <div class="form-group">
                        <button class="btn btn-primary">@Title comment</button>
                    </div>
                </EditForm>
            </div>
        </div>
    </div>
</div>


@code {
    [Parameter]
    public int? CommentId { get; set; }
    [Parameter]
    public int? MatchId { get; set; }
    [Parameter]
    public int? Minute { get; set; }

    [CascadingParameter]
    BlazoredModalInstance ModalInstance { get; set; }

    private MatchCommentaryDTO MatchCommentaryModel{ get; set; } = new MatchCommentaryDTO();
    
    private string Title { get; set; } = "Create";

    protected override async Task OnInitializedAsync()
    {

        if (CommentId != null)
        {
            //update
            Title = "Update";
            MatchCommentaryModel = await MatchCommentaryRepository.Get(CommentId.Value);
        }
        else
        {
            //create
            MatchCommentaryModel = new MatchCommentaryDTO();
            MatchCommentaryModel.Minute = Minute.Value;
        }
    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            //create

            if (MatchCommentaryModel.Id != 0 && Title == "Update")
            {
                //update
                var updateComment = await MatchCommentaryRepository.Update(MatchCommentaryModel, MatchCommentaryModel.Id);
                await JsRuntime.ToastrSuccess("Comment updated successfully");
                await Task.Delay(300);
                ModalDialogParameters returnParameters = new ModalDialogParameters();
                ModalDialog.Close(true, returnParameters);
            }
            else
            {
                //create
                MatchCommentaryModel.MatchId = MatchId.Value;
                var createdResult = await MatchCommentaryRepository.Create(MatchCommentaryModel);

                await JsRuntime.ToastrSuccess("Comment added successfully");
                await Task.Delay(300);
                ModalDialogParameters returnParameters = new ModalDialogParameters();
                ModalDialog.Close(true, returnParameters);
            }
        }
        catch (Exception ex)
        {
            throw ex;

        }
    }
}
